<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               :search.sync="search"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <!--<el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   :disabled="delBatchBtn"
                   v-if="permission.sealhandover_delete"
                   @click="handleDelete">刪 除
        </el-button>-->
        <el-button type="success"
                   size="small"
                   icon="el-icon-search"
                   plain
                   v-if="permission.sealhandover_keep_view"
                   @click="keepVisible = true">保管人查詢
        </el-button>
        <el-button type="primary"
                   size="small"
                   icon="el-icon-download"
                   plain
                   v-if="permission.sealhandover_download"
                   @click="handleDownload">下載
        </el-button>
      </template>

      <template slot="menu" slot-scope="{row, index}">
        <el-button size="small" class="el-button--text" v-if="permission.sealhandover_edit && userInfo.user_id == row.createUser && row.process == 2" @click="$refs.crud.rowEdit(row, index)"><i class="el-icon-edit"></i> 編 輯</el-button>
        <el-button size="small" class="el-button--text" v-if="permission.sealhandover_delete && userInfo.user_id == row.createUser && row.process == 2" @click="$refs.crud.rowDel(row, index)"><i class="el-icon-delete"></i> 刪 除</el-button>
        <el-button size="small" class="el-button--text" v-if="permission.sealhandover_sure && row.process == 2 && row.receiverId == userInfo.user_id" @click="approveForm=row,approveVisible=true"><i class="el-icon-check"></i> 確 認</el-button>
      </template>

      <template slot="receiverNameForm">
        <div v-if="!hasOrgNo">
          <select-dialog-user :id="form.receiverId" :name="form.receiverName" :ehr="form.receiverNo" :disabled="receiverDisabled" :callback="selectCallback"></select-dialog-user>
        </div>
        <div v-if="hasOrgNo">
          <select-dialog-user v-if="hasOrgNo" :id="form.receiverId" :name="form.receiverName" :ehr="form.receiverNo" :disabled="receiverDisabled" :has-org-no="hasOrgNo" :callback="selectCallback"></select-dialog-user>
        </div>
      </template>
      <!--<template slot="handoverPersonNameForm">
        <select-dialog-user :name="form.handoverPersonName" :ehr="form.handoverPersonNo" :callback="handoverSelectCallback"></select-dialog-user>
      </template>-->

      <template slot-scope="{disabled,size}" slot="sealNoSearch">
        <!--        <avue-input placeholder="請選擇內容" v-model="search.sealNos"></avue-input>-->
        <el-input placeholder="請輸入印章編號" v-model="search.sealNo"></el-input>
      </template>

      <template slot="titleForm" slot-scope="{row, index}">
        <div v-html="title" style="white-space: pre-line;color: red;font-weight: bold;"></div>
      </template>
      <template slot="titleLabel" slot-scope="{row, index}">
        <span style="color: red;font-weight: bold;">注意事項：</span>
      </template>

      <template slot="isTurnIn" slot-scope="{row, index}">
        <!--        <el-checkbox v-model="row.isTurnIn" @change="turnInChange"></el-checkbox>-->
        <el-tag size="small " type="success" plain v-if="row.isTurnIn">上繳至上級單位</el-tag>
        <el-tag size="small " type="danger" plain v-if="!row.isTurnIn">非上繳</el-tag>
      </template>

      <template slot="isTurnInForm" slot-scope="{row, index}">
        <el-checkbox v-model="row.isTurnIn" :disabled="turnInDisabled" @change="turnInChange"></el-checkbox>
        <el-tag size="small " type="success" plain v-if="row.isTurnIn">上繳至上級單位</el-tag>
        <el-tag size="small " type="danger" plain v-if="!row.isTurnIn">非上繳</el-tag>
      </template>

      <template slot="process" slot-scope="{row, index}">
        <el-tag size="small " type="warning" plain v-if="row.process == 2">待確認</el-tag>
        <el-tag size="small " type="success" plain v-if="row.process == 3">已確認</el-tag>
      </template>

    </avue-crud>

    <el-dialog :append-to-body="true" :modal-append-to-body="false" :destroy-on-close="true" :fullscreen="true" :visible.sync="keepVisible" title="保管人查詢">
      <div v-if="keepVisible">
        <sealhandover-keep></sealhandover-keep>
      </div>
    </el-dialog>

    <el-dialog title="信息確認"
               append-to-body
               :visible.sync="approveVisible"
               width="70%">
      <sealhandover-sure :form="approveForm" @close="approveVisible = false, onLoad(page)"></sealhandover-sure>
    </el-dialog>

  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove, getByNoAndType, getDownloadList, getCurrentUserKeepList} from "@/api/bank/sealhandover";
  import {mapGetters} from "vuex";
  import { getCurrentDept } from "@/api/system/dept";
  import {dateFormat} from "@/util/date";
  import SelectDialogUser from "@/components/select-dialog/select-dialog-user";
  import {getDeptTree, getTree, getChildsDept} from "@/api/system/dept";
  import {getStandardByCode} from "@/api/bank/handoverstandard";
  import SealhandoverSure from "@/components/common/sealhandover-sure";
  import SealhandoverKeep from "@/views/bank/sealhandover-keep";

  export default {
    name: "init-sealhandover",
    components: {SealhandoverKeep, SealhandoverSure, SelectDialogUser},
    data() {
      return {
        turnInDisabled: false,

        isManageUser: false,
        userKeepList: [],
        currentDept: [],

        title: "",
        search: {},
        receiverDisabled: false,
        keepVisible: false,
        delBatchBtn: true,

        approveForm: {},
        approveVisible: false,

        type: '',
        hasOrgNo: null,
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          addTitle: '新增【業務印章交接登記表】',
          editTitle: '編輯【業務印章交接登記表】',
          viewTitle: '查看【業務印章交接登記表】',
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          editBtn: false,
          delBtn: false,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: '注意事項',
              prop: 'title',
              hide: true,
              formslot: true,
              type: 'text',
              span: 24
            },
            {
              label: "銀行號",
              prop: "bankNo",
              span: 24,
              hide: true,
              disabled: true,
              search: false,
              searchSpan: 4,
              rules: [{
                required: true,
                message: "請輸入銀行號",
                trigger: "blur"
              }]
            },
            {
              label: "機構號",
              prop: "orgNo",
              hide: true,
              disabled: true,
              filterable: true,
              type: "select",
              // dicUrl: `/api/blade-system/expand/dept/getChildsDept`,
              dicData: [],
              props: {
                label: "orgNo",
                value: "orgNo"
              },
              change: ({value, column}) => {
                if (!value) return;
                let dicData = column.dicData;
                dicData.forEach(item => {
                  if (item.orgNo == value){
                    this.form.orgName = item.deptName;
                  }
                })
              },
              rules: [{
                required: true,
                message: "請輸入機構號",
                trigger: "blur"
              }]
            },
            {
              label: "機構名稱",
              prop: "orgName",
              disabled: true,
              type: "select",
              filterable: true,
              dicData: [],
              props: {
                label: "deptName",
                value: "deptName"
              },
              change: ({value, column}) => {
                if (!value) return;
                let dicData = column.dicData;
                dicData.forEach(item => {
                  if (item.deptName == value){
                    this.form.orgNo = item.orgNo;
                  }
                })
              },
              rules: [{
                required: true,
                message: "請輸入機構號",
                trigger: "blur"
              }]
            },
            {
              label: "印章類型",
              prop: "sealTypeSearch",
              type: "select",
              dicUrl: "/api/blade-system/dict/dictionary?code=seal_type",
              props:{
                label: "dictValue",
                value: "dictKey",
              },
              dicFormatter: (res) => {
                let dicData = this.deepClone(res.data);
                // 处理完封存的，再填充给印章类型下拉
                dicData.forEach(item => {item.disabled = item.isSealed == 1;})
                this.findObject(this.option.column, 'sealType').dicData = dicData;
                return res.data;
              },
              search: true,
              // hide: true,
              addDisplay: false,
              editDisplay: false,
              viewDisplay: true,
              searchMultiple: true,
            },
            {
              label: "印章類型",
              prop: "sealType",
              type: "select",
              hide: true,
              addDisplay: true,
              editDisplay: true,
              viewDisplay: false,
              props:{
                label: "dictValue",
                value: "dictKey",
              },
              change: ({value, column}) => {
                if (!value || this.type == 'view') return;
                if (!this.form.sealNo){
                  getByNoAndType(this.form.sealNo, value, this.form.orgNo).then(res => {
                  const data = res.data.data;
                  if (Object.keys(data).length == 0){
                    this.receiverDisabled = false;
                  } else {
                    // 編輯時，若記錄為自己，則跳過
                    if (this.form.id == data.id){
                      return;
                    }
                    if (data.isTurnIn == 1){
                      this.$message.warning("此印章已上繳，請重新選擇！");
                      this.receiverDisabled = true;
                      this.form.sealNo = null;
                    }else{
                      this.receiverDisabled = false;
                    }
                  }
                });
                }

                //支行用户添加交接
                if (!this.isManageUser && this.type == 'add'){
                  let sealObj = value.split('-');
                  this.form.sealType = sealObj[0];
                  this.form.sealNo = sealObj[1];
                }
              },
              rules: [{
                required: true,
                message: "請輸入印章類型",
                trigger: "blur"
              }]
            },
            {
              label: "印章編號",
              prop: "sealNo",
              search: true,
              searchSpan: 4,
              searchslot: true,
              change: ({value, column}) => {
                if (!value ||!this.form.sealType || this.type == 'view') return;
                getByNoAndType(value, this.form.sealType, this.form.orgNo).then(res => {
                  const data = res.data.data;
                  let $handoverNo = this.findObject(this.option.column, 'handoverPersonNo');
                  if (Object.keys(data).length == 0){
                    this.receiverDisabled = false;
                  } else {
                    // 編輯時，若記錄為自己，則跳過
                    if (this.form.id == data.id){
                      return;
                    }
                    if (data.isTurnIn == 1){
                      this.$message.warning("此印章已上繳，請重新選擇！");
                      this.receiverDisabled = true;
                      this.form.sealNo = null;
                    }else{
                      this.receiverDisabled = false;
                    }
                  }
                });
              },
              rules: [{
                required: true,
                message: "請輸入印章編號",
                trigger: "blur"
              }]
            },
            {
              label: "區域/支行",
              prop: "orgNos",
              hide: true,
              display: false,
              searchMultiple: true,
              search: true,
              type: "tree",
              dicData: [],
              props: {
                label: "title",
                value: "key"
              },
              checkStrictly: true,
              rules: [{
                required: true,
                message: "請輸入機構號",
                trigger: "blur"
              }]
            },

            {
              label: "交出人",
              prop: "handoverPersonName",
              // formslot: true,
              disabled: true,
              rules: [{
                required: false,
                message: "請輸入交出人姓名",
                trigger: "change"
              }]
            },
            {
              label: "交出人員工號",
              prop: "handoverPersonNo",
              disabled: true,
              rules: [{
                required: false,
                message: "請輸入交出人員工號",
                trigger: "blur"
              }]
            },
            {
              label: "交接日期",
              prop: "handoverDate",
              type: "datetime",
              format: "yyyy-MM-dd HH:mm",
              valueFormat: "yyyy-MM-dd HH:mm",
              rules: [{
                required: true,
                message: "請輸入交接日期",
                trigger: "blur"
              }]
            },
            {
              label: "是否上繳",
              prop: "isTurnIn",
              formslot: true,
              rules: [{
                required: false,
                message: "請勾選是否上繳",
                trigger: "blur"
              }]
            },
            {
              label: "接收人",
              prop: "receiverName",
              disabled: true,
              search: true,
              searchSpan: 4,
              // formslot: true,
              rules: [{
                required: true,
                message: "請輸入接收人姓名",
                trigger: "change"
              }]
            },
            {
              label: "交接日期",
              prop: "handoverDateRange",
              type: "datetime",
              format: "yyyy-MM-dd HH:mm",
              valueFormat: "yyyy-MM-dd HH:mm",
              searchRange:true,
              hide: true,
              addDisplay: false,
              editDisplay: false,
              viewDisplay: false,
              search: true,
              rules: [{
                required: true,
                message: "請輸入交接日期",
                trigger: "blur"
              }]
            },
            {
              label: "接收人員工號",
              prop: "receiverNo",
              disabled: true,
              rules: [{
                required: true,
                message: "請輸入接收人員工號",
                trigger: "blur"
              }]
            },
            {
              label: "備註",
              prop: "remark",
              rules: [{
                required: false,
                message: "請輸入備註",
                trigger: "blur"
              }]
            },
            {
              label: "填報時間",
              prop: "fillingDate",
              addDisplay: false,
              editDisplay: false,
              rules: [{
                required: true,
                message: "請輸入填報時間",
                trigger: "blur"
              }]
            },
            {
              label: "填報人",
              prop: "fillingPerson",
              addDisplay: false,
              editDisplay: false,
              rules: [{
                required: true,
                message: "請輸入填報人",
                trigger: "blur"
              }]
            },
            {
              label: "進度",
              prop: "process",
              display: false,
            },
            {
              label: "確認時間",
              prop: "sureTime",
              hide: true,
              addDisplay: false,
              editDisplay: false,
              type: "datetime",
              format: "yyyy-MM-dd HH:mm:ss",
              valueFormat: "yyyy-MM-dd HH:mm:ss",
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      ...mapGetters(["userInfo"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.sealhandover_add, false),
          viewBtn: this.vaildData(this.permission.sealhandover_view, false),
          delBtn: this.vaildData(this.permission.sealhandover_delete, false),
          editBtn: this.vaildData(this.permission.sealhandover_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    created() {
      getDeptTree().then(res => {
        const column = this.findObject(this.option.column, "orgNos");
        let treeData = getTree(res.data.data, this.userInfo.dept_id);
        column.dicData = treeData;
        // this.findObject(this.option.column, "orgNo").dicData = treeData;
      });
      getChildsDept().then(res => {
        let dicData = [];
        let data = res.data.data;
        data.forEach(item => {
          if (item.orgNo.indexOf("999") == -1){
            dicData.push(item)
          }
        })
        this.findObject(this.option.column, "orgNo").dicData = dicData;
        this.findObject(this.option.column, "orgName").dicData = dicData;
      });
      getStandardByCode("sealhandover").then(res => {
        const data = res.data.data;
        if (Object.keys(data).length > 0){
          this.title = data.content;
        }else {
          this.option.column.splice(0,1)
        }
      });
      getCurrentUserKeepList().then(res => {
        this.userKeepList = res.data.data;
      });
      getCurrentDept().then(res => {
        const data = res.data.data;
        this.currentDept = data;

        this.isManageUser = data.deptCategory == 1;
        //控制字段顯隱
        this.findObject(this.option.column, "bankNo").display = false;
        this.findObject(this.option.column, "orgNo").display = this.isManageUser;
        this.findObject(this.option.column, "orgName").span = this.isManageUser ? 12 : 24;
      })
    },
    methods: {
      turnInChange(value){
        // this.findObject(this.option.column, "receiverNo").rules[0].required = !value;
        // this.findObject(this.option.column, "receiverName").rules[0].required = !value;
        this.hasOrgNo = value == true ? "51007" : null;
        this.form.receiverNo = null,this.form.receiverName = null;
      },
      handleDownload(){
        if (this.selectionList.length === 0) {
          let tip = "確定下載篩選的" + this.page.total + "條數據嗎？"
          this.$confirm(tip, {
            confirmButtonText: "確定",
            cancelButtonText: "取消",
            type: "warning"
          })
            .then(() => {
              getDownloadList(this.query).then(res => {
                let data = res.data.data;
                data.forEach(item => {item.isTurnIn = item.isTurnIn == 1 ? true : false;item.sealTypeSearch = item.sealType;})
                this.downLoadData(data, true)
              });
            })
        }else{
          this.downLoadData(this.selectionList, false)
        }
      },
      downLoadData(data, isAll){
        let columns = this.deepClone(this.option.column);
        for (let i = 0; i < columns.length; i++) {
          let item = columns[i];
          if (item.hide || item.prop == 'process'){
            columns.splice(i, 1);
            i--;
          }
          if (!isAll && (item.type == 'select' || item.type == 'tree')){
            item.prop = '$' + item.prop;
          }
        }
        this.$Export.excel({
          title: "業務印章交接登記表" || new Date().getTime(),
          columns: columns,
          data: data
        });
      },
      handoverSelectCallback(value){
        this.form.handoverPersonId = value.id;
        this.form.handoverPersonNo = value.ehr;
        this.form.handoverPersonName = value.name;
      },
      selectCallback(value){
        this.form.receiverId = value.id;
        this.form.receiverNo = value.ehr;
        this.form.receiverName = value.name;
      },
      rowSave(row, done, loading) {
        row.isTurnIn = !row.isTurnIn ? 0 : 1;
        if (row.sealType.indexOf('-') != -1){
          let sealObj = row.sealType.split('-');
          row.sealType = sealObj[0];
        }
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        row.isTurnIn = !row.isTurnIn ? 0 : 1;
        if (row.sealType.indexOf('-') != -1){
          let sealObj = row.sealType.split('-');
          row.sealType = sealObj[0];
        }
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("確定將選擇數據刪除?", {
          confirmButtonText: "確定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("請選擇至少一條數據");
          return;
        }
        this.$confirm("確定將選擇數據刪除?", {
          confirmButtonText: "確定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        this.type = type;
        if (type === 'add'){
          //恢复必填
          this.findObject(this.option.column, "receiverNo").rules[0].required = true;
          this.findObject(this.option.column, "receiverName").rules[0].required = true;
          this.receiverDisabled = false;

          this.form.handoverPersonId = this.userInfo.user_id;
          this.form.handoverPersonNo = this.userInfo.user_ehr;
          this.form.handoverPersonName = this.userInfo.user_name;
          this.form.number = 1;
          this.form.handoverDate = dateFormat(new Date(), "yyyy-MM-dd hh:mm");

          const data =  this.currentDept;
          this.form.bankNo = data.bankNo;
          if (data.deptCategory == 1){
            this.isManageUser = true;
            this.findObject(this.option.column, 'orgNo').disabled = false;
            this.findObject(this.option.column, 'sealType').disabled = false;
            this.findObject(this.option.column, 'sealNo').disabled = false;
            done();
          }else{
            this.isManageUser = false;
            this.findObject(this.option.column, 'orgNo').disabled = true;
            this.findObject(this.option.column, 'sealType').disabled = false;
            this.findObject(this.option.column, 'sealNo').disabled = true;
            this.form.orgNo = data.orgNo;
            this.form.orgName = data.deptName;

            getCurrentUserKeepList().then(res => {
              this.userKeepList = res.data.data;
              // 支行用户自行添加交接，需要获取当前用户持有的列表作为下拉内容
              this.findObject(this.option.column, 'sealType').dicData = this.userKeepList;
              done();
            });
          }
        }
        /*if (this.form.isTurnIn){
          // this.turnInChange(true)
        }*/
        if (type == 'edit' && this.form.sealType.indexOf('-') == -1){
          this.form.sealType = this.form.sealType + '-' + this.form.sealNo;
        }
        this.turnInDisabled = type == 'edit'
        if (type == 'edit'){
          this.findObject(this.option.column, 'sealType').disabled = true;
          this.findObject(this.option.column, 'sealNo').disabled = true;
          getCurrentUserKeepList().then(res => {
            this.userKeepList = res.data.data;
            // 支行用户自行添加交接，需要获取当前用户持有的列表作为下拉内容
            this.findObject(this.option.column, 'sealType').dicData = this.userKeepList;
            done();
          });
        }
        if (type == 'view'){
          done();
        }
        // done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        if (params.sealTypeSearch){
          params.sealType = params.sealTypeSearch.join();
          params.sealTypeSearch = [];
        }
        if (params.orgNos){
          params.orgNostr = params.orgNos.join();
          params.orgNos = '';
        }
        if (params.handoverDateRange){
          params.handoverDate_begin = params.handoverDateRange[0], params.handoverDate_end = params.handoverDateRange[1];
          params.handoverDateRange = null;
        }

        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
        if (list && list.length > 0){
          let delFlag = true;
          // permission.keypwd_delete && userInfo.user_id == row.createUser
          for (let i = 0; i < list.length; i++) {
            let item = list[i];
            delFlag = delFlag && item.createUser == this.userInfo.user_id;
          }
          this.delBatchBtn = !delFlag;
        }else{
          this.delBatchBtn = true;
        }
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        params.status = 1;
        // params.process = 2;
        params.createUser = this.userInfo.user_id;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          data.records.forEach(item => {
            item.isTurnIn = item.isTurnIn == 1;
            item.sealTypeSearch = item.sealType;
          })
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
